<?php

defined('JPATH_PLATFORM') or die;

use LMS\Libraries;
use LMS\Libraries\Servicelocator;

JFormHelper::loadFieldClass('list');

class JFormFieldSearch extends JFormFieldList
{	
	protected $type = 'Search';
	
	protected function getInput()
	{		
		$assets = ServiceLocator::get('assets');		
		$assets->addScript('assets/js/fields/search.js');

		$hint = $this->translateHint ? \JText::_($this->hint) : $this->hint;
				
		$size         = !empty($this->size) ? ' size="' . $this->size . '"' : '';
		$maxLength    = !empty($this->maxLength) ? ' maxlength="' . $this->maxLength . '"' : '';
		$class        = !empty($this->class) ? ' class="' . $this->class . '"' : '';
		$readonly     = $this->readonly ? ' readonly' : '';
		$disabled     = $this->disabled ? ' disabled' : '';
		$required     = $this->required ? ' required aria-required="true"' : '';
		$hint         = $hint ? ' placeholder="' . $hint . '"' : '';
		$autocomplete = !$this->autocomplete ? ' autocomplete="off"' : ' autocomplete="' . $this->autocomplete . '"';
		$autocomplete = $autocomplete == ' autocomplete="on"' ? '' : $autocomplete;
		$autofocus    = $this->autofocus ? ' autofocus' : '';
		$spellcheck   = $this->spellcheck ? '' : ' spellcheck="false"';
		$pattern      = !empty($this->pattern) ? ' pattern="' . $this->pattern . '"' : '';
		$inputmode    = !empty($this->inputmode) ? ' inputmode="' . $this->inputmode . '"' : '';
		$dirname      = !empty($this->dirname) ? ' dirname="' . $this->dirname . '"' : '';

		$this->placeholder = $this->getAttribute('placeholder');
		$placeholder  = !empty($this->placeholder) ? ' placeholder="' . constant($this->placeholder) . '"' : '';

		$datalist = '';
		$list     = '';	
				
		$html[] = '			
			<div class="btn-group pull-left input-append">
				<input type="text" name="' . $this->name . '" id="filter_search" ' . $dirname . ' value="'
				. htmlspecialchars($this->value, ENT_COMPAT, 'UTF-8') . '"' . $class . $size . $disabled . $readonly . $list
				. $hint . $maxLength . $required . $autocomplete . $autofocus . $spellcheck . $inputmode . $pattern . $placeholder . ' />
				<button id="search-btn" class="btn btn-default search-btn hasTooltip" title="'._JLMS_SEARCH.'" type="submit"><i class="icon-search"></i></button>
				<button id="reset-btn" class="btn btn-default reset-btn hasTooltip" title="'._JLMS_RESET.'" type="button"><i class="icon-remove"></i></button>
			</div>
		';

		return implode($html);		
	}
}
?>