<?php
/**
 * User: nester_a
 * Date: 04.11.13
 */

namespace LMS\Tools\Conference\Response;

class Response
{
    const STATUS_OK = 0;
    const STATUS_ERROR = 1;

    const TYPE_CONTENT = 'Content';
    const TYPE_OPERATION_RESULT = 'Operation';
    const TYPE_DATA = 'Data';
    const TYPE_FILE = 'File';
    const TYPE_LMS_FILE = 'LMSFile';
    const TYPE_XML_DATA = 'XMLData';
    const TYPE_JSON_DATA = 'JSONData';

    private $content;
    private $status;
    private $type;
    private $headers = array();

    public function __construct($content, $status = self::STATUS_OK, $type = self::TYPE_CONTENT, $headers=false)
    {
        $this->content = $content;
        $this->status = $status;
        $this->type = $type;
        $this->headers = $headers;
    }

    public function getContent()
    {
        return $this->content;
    }

    public function getStatus()
    {
        return $this->status;
    }

    public function getType()
    {
        return $this->type;
    }

    public function getHeaders()
    {
        return $this->headers;
    }


}