<?php
namespace LMS\Tools\Coursebuilder\Repositories;

use LMS\Libraries\Base;
use LMS\Tools\Coursebuilder\Tables;

class LmsLocalMenu extends Base\Repository
{
	public function __construct($options)
	{
		parent::__construct($options);
		$this->table = new Tables\LmsLocalMenu($this->db);
	}

	protected function prepareFilter($query, &$filterOptions)
	{
		$alias = $this->table->getTableAlias();

		$conditions = array();

		if(isset($filterOptions['course_id']) && $filterOptions['course_id']){
			$conditions[] = $alias.".course_id = ".$this->db->quote($filterOptions['course_id']);
		}

		if(isset($filterOptions['user_access']) && $filterOptions['user_access']){
			$conditions[] = $alias.".user_access = ".$this->db->quote($filterOptions['user_access']);
		}

		$query->where($conditions);

		return parent::prepareFilter($query, $filterOptions); // TODO: Change the autogenerated stub
	}

	public function getProhibitedTools($courseId, $userRole)
	{
		return $this->getByFilter(
			array(
				'fields' => 'lmslocalmenu.*, lmslocalmenu.lmsmenu.lang_var, lmslocalmenu.lmsmenu.image',
				'course_id' => $courseId,
				'user_access' => $userRole
			)
		);
	}

}