<?php
namespace LMS\Tools\Homework\View;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Homework extends Base\View
{
	protected $extension = 'com_joomla_lms';
	protected $viewName = 'Homework';

	protected $item;
	protected $form;
	protected $script;

	protected $activityTypes = array(
		1 => 'offline',
		2 => 'write',
		3 => 'upload'
	);

	public $course_id;
	public $id;

	public function __construct($config=array())
	{
		$this->viewDir = __DIR__;
		parent::__construct($config);
	}

	public function display($tpl = null)
	{
		return parent::display($tpl);
	}

	public function editItem()
	{
		$model = $this->getModel('Homework');

		$this->form = $this->get('Form', 'Homework');
		$this->script = $model->getScript();
		$this->toolbar = $this->getToolbarEdit();
		$this->course_id = $model->getState('homework.course_id');

		$this->display('edit');

		$this->setDocument();
	}

	protected function getToolbarEdit()
	{
		$toolbar = new \LMS\Widgets\ContentToolbar();
//		$toolbar->addSaveButton( array('title' => _JLMS_APPLY, 'href' => 'javascript: Joomla.submitbutton(\'homework.homework.apply\')') );
		$toolbar->addSaveButton( array('href' => 'javascript: Joomla.submitbutton(\'homework.homework.save\')') );
//		$toolbar->addSaveButton( array('title' => _JLMS_SAVE2NEW, 'href' => 'javascript: Joomla.submitbutton(\'homework.homework.save2new\')') );
		$toolbar->addCancelButton( array('href' => 'javascript: Joomla.submitbutton(\'homework.homework.cancel\')') );
		return $toolbar->render();
	}

	protected function setDocument()
	{
		$document = \JFactory::getDocument();
		$document->addScript(\JURI::root() . $this->script);
		$document->addScript(\JURI::root() . "components/com_joomla_lms/tools/homework/views/homework/submitbutton.js");
	}

	public function show()
	{
		$modelHomework = $this->getModel('Homework');
		$modelResult = $this->getModel('Result');

		$this->homeworkItem = $modelHomework->getItem();
		$this->form = $modelResult->getForm();
		$this->state = $modelHomework->getState();
		$this->toolbar = $this->getToolbarShow();
		$this->button_upload = $this->getToolbarUpload();

		var_dump($this->form);

		$tmplActivity = isset($this->activityTypes[$this->homeworkItem->activity_type]) ? $this->activityTypes[$this->homeworkItem->activity_type] : 'offline';
		$this->tmplActivity = $tmplActivity;

		$this->display();
	}

	protected function getToolbarShow()
	{
		$toolbar = new \LMS\Widgets\ContentToolbar();
		$toolbar->addBackButton( array('href' => 'javascript: Joomla.submitbutton(\'homework.homework.cancel\')') );
		if(!$this->form->getValue('hw_status')){
			$toolbar->addCustomButton( array('type'=>'custom', 'title' => _JLMS_HW_MARK_COMPLETE, 'icon' => 'checkmark-2', 'href' => 'javascript: Joomla.submitbutton(\'homework.result.mark\')') );
		}
		return $toolbar->render();
	}

	protected function getToolbarUpload()
	{
		jimport('cms.html.toolbar');

		$bar = new \JToolBar( 'toolbar' );

		$bar->appendButton( 'Standard', 'upload', 'Upload', 'homework.result.upload', false );

		return $bar->render();
	}
}

 