<?php
namespace LMS\Tools\Users\Tables;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class UsersInGroups extends Base\Table
{	
	protected $alias = 'student';
	
	function __construct(&$db)
	{
		parent::__construct( '#__lms_users_in_groups', 'id', $db );
	}
	
	protected function initRelations()
	{
		parent::initRelations(); // TODO: Change the autogenerated stub
		
		$config	= ServiceLocator::get('config');
		
		ServiceLocator::load('tool.users');

		$this->relations = array(
			'profile' => array(
				'table' => new JoomlaUsers($this->_db),
				'type' => 'INNER',
				'condition' => '{parent.user_id} = {child.id}',
				'capacity' => self::MANY
			)
		);

		if($config->get('use_global_groups')){
			$this->relations['studentgroup'] = array(
				'table' => new UsersInGlobalGroups($this->_db),
				'type' => 'LEFT',
				'condition' => '{parent.user_id} = {child.user_id}',
				'capacity' => self::MANY
			);
		} else {
			$this->relations['studentgroup'] = array(
				'table' => new UsersInGroups2($this->_db),
				'type' => 'LEFT',
				'condition' => '{parent.user_id} = {child.user_id}',
				'capacity' => self::MANY
			);
		}

		$this->relations['homework_results'] = array(
			'table' => ServiceLocator::get('homeworkResultsTable'),
			'type' => 'LEFT',
			'condition' => '{parent.user_id} = {child.user_id} AND {parent.course_id} = {child.course_id}',
			'capacity' => self::MANY
		);
	}
}
?>